$TITLE Reduced Form Global SAMs for GLOBE Versions 1 2 and EN GTAP8107
$OFFUPPER
*$OFFLISTING OFFSYMXREF OFFSYMLIST
$ONEMPTY

*############## WORK TO DO ON THIS VERSION #############################
$ontext

1.   Estimates of the internal balance for each region are required
     Current version assumes all have values equal to ZERO

2.   Adjustments for income tax payments
     STRONG ASSUMPTION - all factor income taxes are household income taxes
                       - this ignores the social security contributions
                       - in model terms all ss contributions to change
                            additively
                       - subsequent adjustments will be made using GTAP
                            augmentation data (due 2012).

3.   Rounding of database to remove small differences in row and column totals

$offtext

*############## GENERAL INFORMATION #############################
$ontext

This programme was developed by Scott McDonald

 Scott McDonald
 Dept of Economics & Strategy
 Oxford Brookes University
 Wheatley Campus, Wheatley
 Oxford, OX33 1HX, UK
 email:
    smcdonald@brookes.ac.uk

This version works with version 807 of GTAP.

This version last updated 21 May 2013

Scott McDonald, "Deriving Reduced Form Global Social Accounting
Matrices from GTAP version 7 and 8 Data", mimeo.

Copyright (c) 2013 Scott McDonald

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

A copy of the GNU GPL, gpl.txt, is included with the programme files.

Do NOT remove this notice if you redistribute this programme

If you use this programme you should acknowledge the source and not claim
authorship. Altered versions should be clearly distinguished from the original.

$offtext
*############## USER GUIDE ######################################
$ontext

SOFTWARE REQUIREMENTS

  1) This programme is known to work with versions of GAMS 250 after and
     including distribution 23.7. It is believed to work with all versions
     of GAMS 250 that include the GDXXRW utilities, i.e, since
     distribution 21.0 in May 2003.

  2) It is also useful to have a copy of GDXVIEWER - this is one of the
     WTOOLS utilities developed by Erwin Kalvelagen. GDXViewer is now
     packaged with GAMS.

DATA REQUIREMENTS

  1) No GTAP data are provided. The user must have a licensed version
     of the GTAP database complete with the GTAPAgg programme.

  2) The computer code and instructions for generating a Global SAM from
     the GTAP database are available from www.cgemod.org.uk and
     the GTAP web site

  2) All the sets and set mapping required to use the GAMS programmes for
     specific versions of the GTAP database are provided from
     a single Excel workbook.

USER INSTRUCTIONS
   (These instructions assume the user is working in a Windows XP/Vista
    environment using GAMSIDE and Microsoft Excel 2003 or 2007)

  1) The programme files are made available in a WinZip archive - ???.zip.

  2) The programme files are organised so that they can be used as a
     GAMS User Model Library (see the GAMS documentation for information
     on using User Model Libraries). These instruction assume that files
     in ???.zip have been extracted to a directory - ???.

  3) Create a directory for the programme. The path to this directory
     does not need to follow standard/old DOS conventions.

     Create a project file (*.gpr) in this directory.

  4) To copy the programme files to the project directory.
     In GAMSIDE with the project file controlling paths do the following
     a) Locate the User Model Library
          File>Model Library>Open User Model Library and then select the
          file ???.glb in the directory gsamlib
     b) Double click on the NAME of the version of the programme that
        corresponds to the version of the GTAP database with which you are
        working. ALL the files needed to run the programme other than the
        GTAP database file will be copied to the directory containing the
        project file.
        NB: A brief description of the programme is provided in the window
            at the bottom of the User Mode Library window.

  5) Read and study the GAMS programme.

  6) Create the database for the programme

  7) Check that programme compiles (by using SHIFT+F9).
        If the steps above have been followed there should be no problems.
        a) Some users can have problems with the GDXXRW facility
           that generates the file data_in.gdx from the Excel file. These
           problems mostly seem to originate with a corruption of the
           'LAYOUT' worksheet and result in an error message saying the
           file data_in.gdx does not exist. To overcome this type of problem
              i)  check that gdxxrw.exe exists in the GAMS directory
              ii) copy the contents of the worksheet 'LAYOUT2' and replace
                  the worksheet 'LAYOUT' using Paste Special
        b) .

  8) Run the programme. The output to the working directory should be as
     follows:
     a)
     b)
     c)

     NB: For version 6 of the GTAP database the directory will be in the
         order of ???MB.

  9)

  10)

  11)These notes relate to situations where a user wishes to work with
     another version of the GTAP database. It is assumed this will be a later
     version.
     A new workbook - data_gtp_**.xls - will need to be compiled.
     a) Using the file gtp_sets_v60.xls as a template
        i)   Get the 'new' sector, region, factor and margin codes and
             descriptions from the GTAP database and copy them into the
             worksheet 'Set data from GTAPAgg'
        ii)  Check that the worksheets
             'Set creation regions/sectors/factor/margins' have all updated
             correctly - NB the number of entries in each group of
             codes is the critical point.
        iii) Compile the new sets in the worksheet 'Compiling Sets'
     b) Using the file data_gtp_60.xls as a template
        i)   Generate a revise worksheet 'Sets' - using copy and paste
             SPECIAL from the new file gtp_sets_V**.xls.
        ii)  Generate a revise worksheet 'Maps' - using copy and paste
             from the new worksheet 'Sets'.
        iii) The worksheet 'Layout' should NOT need to be changed unless
             new sets or maps are created.
     c) Update the programme file to read the new sets and maps.

     d) Some general suggestions
        i)   Spaces in the cells of the file data_gtp_**.xls are a
             problem - to GAMS spaces are characters.
        ii)  If the orderings in the mapping sets are not consistent the
             mappings implemented will be wrong.
        iii) 'Corruption' of the worksheet 'Layout' will cause the sets
             maps not to be read in.
        iv)  The codes used for account names in the GTAP database may
             have changed.
        v)   'Big' initial 'errors' (say entries in the first DIFFTOT that
             are greater than 1) are likely to be due to an error in the
             sets and maps files.
        vi)  'Small' initial 'errors' (say less that 0.01) are more likely
             to rounding issues due to the degree of precision in the
             GTAP database.
        vii) When adjusting the programme to remove 'errors' due to
             the degree precision in the database, it is best by far to
             work through the accounts as they appear in the SAM, i.e.,
             start with the import commodity accounts, then domestic
             commodities, etc.

$offtext
*############## PROGRAMME DESCRIPTION ##################################
$ontext
This programme reorganises GTAP SAM data into the version of a Global SAM
used by version 2 of the GLOBE model (GLB2).

 The programme
        adjusts for the law of one price
        generates data for the Globe region



The imported and domestic commodity accounts are aggregated to follow a
composite commodity type model - see Lewis, Robinson & Thierfelder (2000)
for an example of this type of representation.


$offtext
*############## 1. OUTLINE OF PROGRAMME ################################

$ontext
Programme Navigation

     PROGRAMME DESCRIPTION



$offtext


*############## 2. SET and PARAMETER DECLARATIONS ##########################

*#### SET DECLARATIONS

SETS

 ss              SAM accounts

 ssn(ss)         SAM accounts excluding TOTAL

*   Commodity sets
 mcc(ss)         Imported Commodities
 mcceg(mcc)      Imported Energy commodities
 mccegn(mcc)     Imported Non Energy commodities

 dcc(ss)         Domestic Commodities
 dcceg(dcc)      Domestic Energy commodities
 dccegn(dcc)     Domestic Non Energy commodities

 cc(ss)          Composite Commodities

 cceg(cc)        Energy commodities
 ccegn(cc)       Non Energy commodities

 en              Alternative energy commodities

 cct(cc)         Margin Commodities

*   Activity sets
 aa(ss)          Activities
 a2              Production commodities Activities in GTAP

*   Factor sets
 ff (ss)         Factors

*   Tax sets
 tmmtax(ss)      Ad valorem equivalent Import duties
 tmsstax(ss)     Specific Import duties
 teetax(ss)      Export taxes
 smmtax(ss)      Sales Taxes on imported goods and services
 sddtax(ss)      Sales Taxes on domestic goods and services
 sstax(ss)       Sales Taxes on composite goods and services
 fftax(ss)       Taxes on Factors

*   Trade sets
 otppmarg(ss)    Other trade and transport costs
 wtppmarg(ss)    Water trade and transport costs
 atppmarg(ss)    Air trade and transport costs

 vsttmarg(ss)    Exports of trade and transport services

 ww(ss)          Rest of the World

*   investment sets
 ii(ss)          Investment

*   Regions set
 kk              Regions
 kkn(kk)         Regions except GLO

*   Time Periods set
 tt              time periods 1965 to 2010


*   Mapping sets

 map_mcc_smmtax(mcc,smmtax)  Mapping from smmtax to mcc Import Sales tax mapping
 map_smmtax_mcc(smmtax,mcc)  Mapping from mcc to smmtax Import Sales tax mapping

 map_sstax_smmtax(sstax,smmtax)  Mapping from smmtax to sstax

 map_dcc_sddtax(dcc,sddtax)     Mapping from sddtax to dcc Domestic Sales tax
 map_sddtax_dcc(sddtax,dcc)     Mapping from dcc to sddtax Domestic Sales tax

 map_sstax_sddtax(sstax,sddtax)  Mapping from sddtax to sstax

 map_cc_mcc(cc,mcc)       Mapping from mcc to cc Imports to Composite commodity

 map_cc_dcc(cc,dcc)       Mapping from dcc to cc Domestic to Composite commodity

 map_mcc_dcc(mcc,dcc)     Mapping from dcc to mcc

 map_dcc_mcc(dcc,mcc)     Mapping from mcc to dcc

 map_ww_kk(ww,kk)         Mapping from kk to ww Trade account

 map_kk_ww(kk,ww)         Mapping from ww to kk Trade account

 map_cc_en(ss,en)         Mapping from energy to composite commodities

 map_sstax_cc(sstax,cc)   Mapping from composite commodities to sales taxes

 map_tmm_tms(tmmtax,tmsstax)   Mapping to tmmtax from tmsstax

*  Report sets

 tsmset       sets for summary info on sales taxes on imports commod
 tsdset       sets for summary info on sales taxes on domestic commod

* Set used to control model flow

 cons         set of programme controlling parameters

* Other sets
 inst(ss)     Domestic final demand institutions - hhold govt kap
 nonhh(ss)    Activities government and investment saving demand

      ;

* Setting up ALIASES

 ALIAS(ss,ssp), (ssn,ssnp,ssnpp),
      (mcc,mccp), (dcc,dccp), (cc,ccp), (cct,cctp),
      (cceg,ccegp), (mcceg,mccegp), (dcceg,dccegp), (en,enp),
      (aa,aap), (a2,aa2),
      (ff,ffp,endow_comm),
      (tmmtax,tmmtaxp), (tmsstax,tmsstaxp),
      (teetax,teetaxp),
      (smmtax,smmtaxp), (sddtax,sddtaxp), (sddtax,sddtaxp),
      (fftax,fftaxp),
      (otppmarg,otppmargp), (wtppmarg,wtppmargp), (atppmarg,atppmargp),
      (vsttmarg,vsttmargp),
      (ww,wwp), (kk,kkp,regp),
      (inst,instp), (nonhh,nonhhp)
 ;

*#### PARAMETER DECLARATIONS

PARAMETERS
* GTAP Global SAM
 SAMG(ss,ssp,kk)        Social accounting matrices for regions k

* Factor based
 FacSubs(ff,aa,kk)      Factor-Based Subsidies by activity and region
 FacEmpTax(ff,aa,kk)    Factor Employment Tax Revenue

* Activity based
 OutSubs(dcc,kk)        Ordinary Output Subsidies

* Intermediate Input based
 IntInSubsM(mcc,aa,kk)  Imported intermediate input subsidies
 IntInSubsD(dcc,aa,kk)  Domestic intermediate input subsidies

* Export based
 MFASubs(dcc,ww,kk)     MFA Export Subsidy Equivalents
 OrdXSub(dcc,ww,kk)     Ordinary Export subsidies

* Import based
 OrdMDuty(ww,mcc,kk)    Ordinary Import duties

* GTAP Elasticities
 ESUBVA(aa)         CES between primary factors in production
 ESUBD(mcc)         Armington CES for domestic_imported allocation
 ESUBM(mcc)         Armington CES for regional allocation of imports

* GTAP Energy Volumes
 EVolDA(en,aa,kk)   volume of input domestic purchases by activities (Mtoe)
 EVolDH(en,kk)      volume of domestic purchases by households (Mtoe)
 EVolDG(en,kk)      volume of domestic purchases by government (Mtoe)
 EVolDI(en,kk)      volume of domestic purchases by investment (Mtoe)

 EVolIA(en,aa,kk)   volume of input import purchases by activities (Mtoe)
 EVolIH(en,kk)      volume of import purchases by households (Mtoe)
 EVolIG(en,kk)      volume of import purchases by government (Mtoe)
 EVolII(en,kk)      volume of import purchases by investment (Mtoe)

 EVolT(en,kk,kk)    volume of bilateral trade (Mtoe)

* GTAP Population data

 POPn(kk)           Population by region

* GTAP Capital Stock Trade data

 Kstoc(kk)          Capital stocks by region

* GTAP Time Series Trade data

 TSTRAD(dcc,kk,ww,tt)   Time series of trade flows between regions


 roundpar           Rounding parameter

* Parameters used to control model flow

 controls(cons,*)   initial values for controlling parameters

 DISP1              Control on DISPLAY Statements for read in SETS and DATA
 DISP2              Control on general DISPLAY Statements
 OUTGDXv1           Control on GDX Unload for SAMG v1
 OUTGDXv2           Control on GDX Unload for SAMG v2
 OUTGDXv3           Control on GDX Unload for SAMG v3
 OUTGDXv3g          Control on GDX Unload for SAMG v3g
 OUTGDXv_M          Control on GDX Unload for SAMG_M
 OUTREP             Control on Report outpurs

* Sales Tax rate parameters

 tsm(mcc,ss,kk)     Sales Taxes rates on imported commod by agents
 tsmnonh(mcc,kk)    Sales Taxes rates on imported commod by non hhold demand
 tvm(mcc,kk)        Implied VAT rates on imported commod by households

 tsd(dcc,ss,kk)     Sales Taxes rates on domestic commod by agents
 tsdnonh(dcc,kk)    Sales Taxes rates on domestic commod by non hhold demand
 tvd(dcc,kk)        Implied VAT rates on domestic commod by households

* Sales Tax revenue parameters

 SMTAX(mcc,ss,kk)   Sales Taxes revenues on imported commod by agents
 SDTAX(dcc,ss,kk)   Sales Taxes revenues on domestic commod by agents

 STAX(cc,ss,kk)     Sales Taxes revenues on composite commod by agents

* Sales Tax Report parameters

 tsmrates(kk,mcc,tsmset)  Summary info on sales taxes on imported commod
 tsdrates(kk,dcc,tsdset)  Summary info on sales taxes on domestic commod

* Value Added Tax Report parameters

 tvmrates(kk,mcc,tsmset)  Summary info on VAT taxes on imported commod
 tvdrates(kk,dcc,tsdset)  Summary info on VAT taxes on domestic commod

 tvmratesNEG(kk,mcc,tsmset)  Negative VAT taxes on imported commod
 tvdratesNEG(kk,dcc,tsdset)  Negative VAT taxes on domestic commod

* Count on members of sets

 mcc_CNT            Count on members of mcc
 dcc_CNT            Count on members of dcc
 cc_CNT             Count on members of cc

   ;

*############## 3. SET AND PARAMETER ASSIGNMENTS ##########################

* SETS are read in from an Excel

$CALL "GDXXRW i=data_glbsam_8107_GLB2.xlsx o=data_in.gdx INDEX=LAYOUT!A4"

$GDXIN data_in.gdx

* SAMG Sets
$LOADdc ss
$LOADdc mcc mcceg dcc dcceg cc cceg en cct
$LOADdc aa a2
$LOADdc ff
$LOADdc tmmtax tmsstax teetax smmtax sddtax sstax fftax
$LOADdc otppmarg wtppmarg atppmarg vsttmarg
$LOADdc ww
$LOADdc ii
$LOADdc kk
$LOADdc tt
* Sets for reports on tax rates
$LOADdc tsmset tsdset
* Set for controlling parameters
$LOAD cons
* SEts for MAPS
$LOADdc map_mcc_smmtax map_smmtax_mcc map_sstax_smmtax map_mcc_dcc
$LOADdc map_dcc_sddtax map_sddtax_dcc map_dcc_mcc
$LOADdc map_sstax_sddtax  map_sstax_cc
$LOADdc map_cc_mcc map_cc_dcc map_ww_kk map_kk_ww
$LOADdc map_cc_en
$LOADdc map_tmm_tms

* Values for controlling parameters
$LOAD controls

$GDXIN

$GDXIN gtpdatav8107.gdx

*$LOAD SAMG   = SAMG_v1
$LOAD SAMG   = SAMG_v2

$LOAD FacSubs     = FacSubs
$LOAD FacEmpTax   = FacEmpTax
$LOAD OutSubs     = OutSubs
$LOAD IntInSubsM  = IntInSubsM
$LOAD IntInSubsD  = IntInSubsD
$LOAD MFASubs     = MFASubs
$LOAD OrdXSub     = OrdXSub
$LOAD OrdMDuty    = OrdMDuty

$LOADdc ESUBVA = ESUBVA
$LOADdc ESUBD  = ESUBD
$LOADdc ESUBM  = ESUBM

* GTAP Energy Volumes

$LOADdc EVolDA = EVolDA
$LOADdc EVolDH = EVolDH
$LOADdc EVolDG = EVolDG
$LOADdc EVolDI = EVolDI

$LOADdc EVolIA = EVolIA
$LOADdc EVolIH = EVolIH
$LOADdc EVolIG = EVolIG
$LOADdc EVolII = EVolII

$LOADdc EVolT  = EVolT

$LOAD POPn = POPn

$LOAD KStoc

$LOAD TSTRAD = TSTRAD

$GDXIN


* Assigning the rounding parameter

 roundpar      = 6 ;

* Assigning values to control parameters

 DISP1         = controls("conDISP1","base") ;
 DISP2         = controls("conDISP2","base") ;
 OUTGDXv1      = controls("conOUTGDXv1","base") ;
 OUTGDXv2      = controls("conOUTGDXv2","base") ;
 OUTGDXv3      = controls("conOUTGDXv3","base") ;
 OUTGDXv3g     = controls("conOUTGDXv3g","base") ;
 OUTGDXv_M     = controls("conOUTGDXv_M","base") ;
 OUTREP        = controls("conOUTREP","base") ;

* Defining set members by reference to previously defined sets

 mccegn(mcc)    = NOT mcceg(mcc) ;
 dccegn(dcc)    = NOT dcceg(dcc) ;
 ccegn(cc)      = NOT cceg(cc) ;

* SAM Accounts excluding totals
 ssn(ss)        = YES ;
 ssn("TTOTAL")  = NO ;

* Regions excluding glo
 kkn(kk)        = YES ;
 kkn("glo")     = NO ;

* Other sets

 inst("hhous")  = YES ;
 inst("ggovt")  = YES ;
 inst("kkap")   = YES ;

 nonhh(aa)      = YES ;
 nonhh("ggovt") = YES ;
 nonhh("kkap")  = YES ;

 mcc_CNT        = 57 ;
 dcc_CNT        = 57 ;
 cc_CNT         = 57 ;

IF(DISP1 = 1,

DISPLAY SAMG, controls ;

DISPLAY ss, ssn,
        mcc, mcceg, mccegn, dcc, dcceg, dccegn, cc, cceg, ccegn, cct,
        inst, nonhh,
        aa, a2,
        ff,
        tmmtax, tmsstax, teetax, smmtax, sddtax, sstax, fftax,
        otppmarg, wtppmarg, atppmarg, vsttmarg,
        ww, ii, kk, kkn ;

DISPLAY tsmset, tsdset ;

DISPLAY map_mcc_smmtax, map_smmtax_mcc, map_sstax_smmtax,
        map_dcc_sddtax, map_sddtax_dcc, map_sstax_sddtax, map_sstax_cc,
        map_cc_mcc, map_cc_dcc, map_ww_kk, map_kk_ww, map_cc_en, map_tmm_tms ;

DISPLAY mcc_CNT, dcc_CNT, cc_CNT ;

   ) ;

Display
 SAMG
 FacSubs
 FacEmpTax
 OutSubs
 IntInSubsM
 IntInSubsD
 MFASubs
 OrdXSub
 OrdMDuty
 ESUBVA
 ESUBD
 ESUBM
 EVolDA
 EVolDH
 EVolDG
 EVolDI
 EVolIA
 EVolIH
 EVolIG
 EVolII
 EVolT
 POPn
 KStoc
 TSTRAD

 ;

*############## 4. SALES TAX CALCULATION #################################

*### Assigning Sales Tax revenue parameters

* Imports by Activities
 SMTAX(mcc,aa,kkn)      = SUM(smmtax
                          $map_mcc_smmtax(mcc,smmtax),
                          SAMG(smmtax,aa,kkn)) ;

* Imports by Institutions
 SMTAX(mcc,inst,kkn) = SUM(smmtax
                          $map_mcc_smmtax(mcc,smmtax),
                          SAMG(smmtax,inst,kkn)) ;

* Domestic by Activities
 SDTAX(dcc,aa,kkn)      = SUM(sddtax
                          $map_dcc_sddtax(dcc,sddtax),
                          SAMG(sddtax,aa,kkn)) ;

* Domestic by Institutions
 SDTAX(dcc,inst,kkn) = SUM(sddtax
                          $map_dcc_sddtax(dcc,sddtax),
                          SAMG(sddtax,inst,kkn)) ;

* Total Sales taxes by Institutions
 STAX(cc,ss,kkn)     = SUM(mcc$map_cc_mcc(cc,mcc),SMTAX(mcc,ss,kkn))
                         + SUM(dcc$map_cc_dcc(cc,dcc),SDTAX(dcc,ss,kkn)) ;

*### CALCULATING IMPLIED TAX RATES

* Parameters used in tax rate calculations only

Parameters

 tvmratesNEGCNT    COUNT on negative VAT rates on Imports
 tvdratesNEGCNT    COUNT on negative VAT rates on Domestic

 tvm2(mcc,kk)      Applied VAT rates on imported commod by households
 tvd2(dcc,kk)      Applied VAT rates on domestic commod by households

 tvm2NEGCNT        COUNT on negative tvm2 VAT rates on Imports
 tvd2NEGCNT        COUNT on negative tvd2 VAT rates on Domestic
 ;

*---- GTAP's Implied Sales Tax Rates

* Sales tax rates on imports

 tsm(mcc,aa,kkn)$SAMG(mcc,aa,kkn) = SMTAX(mcc,aa,kkn)/SAMG(mcc,aa,kkn) ;

 tsm(mcc,inst,kkn)$SAMG(mcc,inst,kkn) = SMTAX(mcc,inst,kkn)/SAMG(mcc,inst,kkn) ;

 tsmnonh(mcc,kkn)$(SUM(nonhh,SAMG(mcc,nonhh,kkn)))
                        = SUM(nonhh,SMTAX(mcc,nonhh,kkn))
                            /SUM(nonhh,SAMG(mcc,nonhh,kkn)) ;

 tvm(mcc,kkn)            = tsm(mcc,"hhous",kkn) - tsmnonh(mcc,kkn) ;

* Sales tax rates on domestic commodities

 tsd(dcc,aa,kkn)$SAMG(dcc,aa,kkn) = SDTAX(dcc,aa,kkn)/SAMG(dcc,aa,kkn) ;

 tsd(dcc,inst,kkn)$SAMG(dcc,inst,kkn) = SDTAX(dcc,inst,kkn)/SAMG(dcc,inst,kkn) ;

 tsdnonh(dcc,kkn)$(SUM(nonhh,SAMG(dcc,nonhh,kkn)))
                        = SUM(nonhh,SDTAX(dcc,nonhh,kkn))
                            /SUM(nonhh,SAMG(dcc,nonhh,kkn)) ;

 tvd(dcc,kkn)            = tsd(dcc,"hhous",kkn) - tsdnonh(dcc,kkn) ;

*DISPLAY tsma ;

 tsmrates(kkn,mcc,"mintsma")   = SMIN(aa$tsm(mcc,aa,kkn),tsm(mcc,aa,kkn)) ;
 tsmrates(kkn,mcc,"avtsma")    = SUM(aa,tsm(mcc,aa,kkn))/mcc_CNT ;
 tsmrates(kkn,mcc,"maxtsma")   = SMAX(aa,tsm(mcc,aa,kkn)) ;
 tsmrates(kkn,mcc,"tsmhous")   = tsm(mcc,"hhous",kkn) ;
 tsmrates(kkn,mcc,"tsmgovt")   = tsm(mcc,"ggovt",kkn) ;
 tsmrates(kkn,mcc,"tsmkap")    = tsm(mcc,"kkap",kkn) ;
 tsmrates(kkn,mcc,"tsmnonhh")  = tsmnonh(mcc,kkn) ;
 tsmrates(kkn,mcc,"tvmhh")     = tvm(mcc,kkn) ;

 tsdrates(kkn,dcc,"mintsda")   = SMIN(aa$tsd(dcc,aa,kkn),tsd(dcc,aa,kkn)) ;
 tsdrates(kkn,dcc,"avtsda")    = SUM(aa,tsd(dcc,aa,kkn))/dcc_CNT ;
 tsdrates(kkn,dcc,"maxtsda")   = SMAX(aa,tsd(dcc,aa,kkn)) ;
 tsdrates(kkn,dcc,"tsdhous")   = tsd(dcc,"hhous",kkn) ;
 tsdrates(kkn,dcc,"tsdgovt")   = tsd(dcc,"ggovt",kkn) ;
 tsdrates(kkn,dcc,"tsdkap")    = tsd(dcc,"kkap",kkn) ;
 tsdrates(kkn,dcc,"tsdnonhh")  = tsdnonh(dcc,kkn) ;
 tsdrates(kkn,dcc,"tvdhh")     = tvd(dcc,kkn) ;

*---- Adjusting Implied VAT rates

* Implied VAT rates

 tvmrates(kkn,mcc,"tvmhh")     = tvm(mcc,kkn) ;
 tvdrates(kkn,dcc,"tvdhh")     = tvd(dcc,kkn) ;

* Identifiying negative VAT rates

 tvmratesNEG(kkn,mcc,"tvmhh")$(tvm(mcc,kkn) LT 0.0)   = tvm(mcc,kkn) ;
 tvdratesNEG(kkn,dcc,"tvdhh")$(tvd(dcc,kkn) LT 0.0)   = tvd(dcc,kkn) ;


 tvmratesNEGCNT = SUM((kk,mcc)$tvmratesNEG(kk,mcc,"tvmhh"),1) ;
 tvdratesNEGCNT = SUM((kk,dcc)$tvdratesNEG(kk,dcc,"tvdhh"),1) ;

Display
  tvmratesNEGCNT, tvdratesNEGCNT
 ;

* Defining APPLIED VAT rates as positive IMPLIED VAT rates

 tvm2(mcc,kkn)     = tvm(mcc,kkn) - tvmratesNEG(kkn,mcc,"tvmhh") ;
 tvd2(dcc,kkn)     = tvd(dcc,kkn) - tvdratesNEG(kkn,dcc,"tvdhh") ;

 tvm2NEGCNT = SUM((kkn,mcc)$(tvm2(mcc,kkn) LT 0.0),1) ;
 tvd2NEGCNT = SUM((kkn,dcc)$(tvd2(dcc,kkn) LT 0.0),1) ;

Display
  tvm2NEGCNT, tvd2NEGCNT
 ;

option tsmrates: 6:1:1 ;
option tsdrates: 6:1:1 ;

option tvmrates: 6:1:2 ;
option tvdrates: 6:1:2 ;

IF(DISP2 = 1,

DISPLAY SMTAX, SDTAX,
        tsm, tsmnonh, tvm, tsd, tsdnonh, tvd,
        tsmrates, tsdrates, tvmrates, tvdrates,
        tvmratesNEG, tvdratesNEG, tvmratesNEGCNT, tvdratesNEGCNT
        tvm2, tvd2, tvm2NEGCNT, tvd2NEGCNT
 ;
  ) ;

*## Writing out the Sales Tax Rates results to GDX

IF(OUTREP = 1,

Execute_Unload  'glbsam8107_SalTaxes.gdx',
 SMTAX
 SDTAX
 tsm
 tsmnonh
 tvm
 tsd
 tsdnonh
 tvd
 tsmrates
 tsdrates
 tvmrates
 tvdrates
 tvmratesNEG
 tvdratesNEG
 tvmratesNEGCNT
 tvdratesNEGCNT
  ;

   )  ;


*############## 5. GLOBE SAMG with SIMPLE SALES TAXES and VAT ##########

*------- 5a. Creating SAMG from GTAP in a SAM
$ontext

This stage creates a SAM under the implicit assumption that a law of
one price held in the base GTAP data. It is also assumed that the internal
balance for all regions was zero in the base period.

Separation of imported and domestic commodities is maintained.

The artifice of a Regional Household is removed.

The globe region is introduced to account for trade in margins.

$offtext

*#### Import commodity income components

* Revaluing imported commodities at purchaser prices

* Import Intermediate Use matrices (1:3)

 SAMG(mcc,aa,kkn)       = SAMG(mcc,aa,kkn) +  SMTAX(mcc,aa,kkn) ;

* Institution import demand vectors (1:6; 1:13; 1:14)

 SAMG(mcc,inst,kkn)     = SAMG(mcc,inst,kkn) +  SMTAX(mcc,inst,kkn) ;

*#### Domestic commodity income components

* Revaluing domestic commodities at purchaser prices

* Domestic Intermediate Use matrices (2:3)

 SAMG(dcc,aa,kkn)       =  SAMG(dcc,aa,kkn) + SDTAX(dcc,aa,kkn) ;

* Institution domestic demand vectors (2:6; 2:13; 2:14)

 SAMG(dcc,inst,kkn)     =  SAMG(dcc,inst,kkn) + SDTAX(dcc,inst,kkn) ;

*#### Indirect Tax Receipts for INDTAX(r) in GTAP model

* Deleting commodity specific sales taxes

* Intermediate Inputs (8:3)

 SAMG(smmtax,aa,kkn)    = 0.0 ;

* Institution Demand (9:6; 9:13; 9:14)

 SAMG(smmtax,inst,kkn)  = 0.0 ;

*# Domestic Sales Taxes

* Intermediate Inputs (8:3)

 SAMG(sddtax,aa,kkn)    = 0.0 ;

* Institution Demand (8:6; 8:13; 8:14)

 SAMG(sddtax,inst,kkn)  = 0.0 ;

* Total Value Added Taxes Revenues on imports

 SAMG("vvattax",mcc,kkn)  = (tvm2(mcc,kkn) * SAMG(mcc,"hhous",kkn)) ;

* Total Value Added Taxes Revenues on domestic commodities

 SAMG("vvattax",dcc,kkn)  = (tvd2(dcc,kkn) * SAMG(dcc,"hhous",kkn)) ;

* Total Sales Taxes Revenues with common Sales Tax rates

 SAMG("ssaltax",mcc,kkn)  =  SUM(aa,SMTAX(mcc,aa,kkn))
                            + (SMTAX(mcc,"hhous",kkn)
                                 - (tvm2(mcc,kkn) * SAMG(mcc,"hhous",kkn)))
                            + SMTAX(mcc,"ggovt",kkn)
                            + SMTAX(mcc,"kkap",kkn) ;

* On domestic commodities

 SAMG("ssaltax",dcc,kkn)  =  SUM(aa,SDTAX(dcc,aa,kkn))
                            + (SDTAX(dcc,"hhous",kkn)
                                 - (tvd2(dcc,kkn) * SAMG(dcc,"hhous",kkn)))
                            + SDTAX(dcc,"ggovt",kkn)
                            + SDTAX(dcc,"kkap",kkn) ;

* Production taxes paid by activity

* Factor Use taxes paid by activities

 SAMG(fftax,aa,kkn)       = SAMG(fftax,aa,kkn) ;

* Indirect Production taxes to maintain activity account totals

 SAMG("pprodtax",aa,kkn)  = SAMG("ttotal",aa,kkn)
                           - (SUM(mcc,SAMG(mcc,aa,kkn))
                                   + SUM(dcc,SAMG(dcc,aa,kkn))
                           + SUM(ff,SAMG(ff,aa,kkn))
                                   + SUM(fftax,SAMG(fftax,aa,kkn))) ;

*#### Components of Regional Household Income

* Deleting commodity specific sales taxes

* Domestic Sales taxes (5:8)

 SAMG("rreghous",sddtax,kkn)  = 0.0 ;

* Import Sales taxes (5:9)

 SAMG("rreghous",smmtax,kkn)  = 0.0 ;

* Adding Value Added Taxes Revenues

 SAMG("rreghous","vvattax",kkn)  = SUM(mcc,SAMG("vvattax",mcc,kkn))
                                  + SUM(dcc,SAMG("vvattax",dcc,kkn)) ;

* Adding Sales Taxes Revenues

 SAMG("rreghous","ssaltax",kkn)  = SUM(mcc,SAMG("ssaltax",mcc,kkn))
                                  + SUM(dcc,SAMG("ssaltax",dcc,kkn)) ;

* Production Taxes (5:11)

* Updating Reg House income from production taxes

 SAMG("rreghous","pprodtax",kkn)
                         = SUM(aa,SAMG("pprodtax",aa,kkn)) ;

* Calculating Total Income of Regional Household

 SAMG("rreghous","TTOTAL",kkn)  = SUM(ff,SAMG("rreghous",ff,kkn))
                                + SUM(tmmtax,SAMG("rreghous",tmmtax,kkn))
                                + SUM(tmsstax,SAMG("rreghous",tmsstax,kkn))
                                + SUM(teetax,SAMG("rreghous",teetax,kkn))
                                + SAMG("rreghous","ssaltax",kkn)
                                + SAMG("rreghous","vvattax",kkn)
                                + SUM(fftax,SAMG("rreghous",fftax,kkn))
                                + SAMG("rreghous","pprodtax",kkn)
                                + SAMG("rreghous","ddirtax",kkn)  ;

*#### Removing the Regional Household Account

* Income of Private Households (6:5)

 SAMG("hhous","rreghous",kkn)  = SUM(mcc,SAMG(mcc,"hhous",kkn))
                                + SUM(dcc,SAMG(dcc,"hhous",kkn)) ;

* Income of Government (13:5)

 SAMG("ggovt","rreghous",kkn) = SUM(mcc,SAMG(mcc,"ggovt",kkn))
                               + SUM(dcc,SAMG(dcc,"ggovt",kkn)) ;

* Domestic Savings (14:5)

 SAMG("kkap","rreghous",kkn)  = SAMG("rreghous","ttotal",kkn)
                               - SAMG("hhous","rreghous",kkn)
                               - SAMG("ggovt","rreghous",kkn) ;

* Income of Private Households (6:5)
* Moving factor incomes and income taxes to HOUS from REG HOUSE and DDIRTAX
* STRONG ASSUMPTION - all factor income taxes are household income taxes
*                   - this ignores the social security contributions

 SAMG("hhous",ff,kkn)      = SAMG("rreghous",ff,kkn) + SAMG("ddirtax",ff,kkn) ;

 SAMG("RREGHOUS",ss,kkn)   = 0.0 ;

 SAMG("rreghous",ff,kkn)   = 0.0 ;

 SAMG("hhous","rreghous",kkn)  = 0.0 ;

* Income Tax paid by private household

 SAMG("ddirtax","hhous",kkn) = SUM(ff,SAMG("ddirtax",ff,kkn)) ;

 SAMG("ddirtax",ff,kkn)      = 0.0 ;

* Income of Government (13:5)
* Moving components of indirect taxes from REG HOUSE to GOVT

 SAMG("ggovt",tmmtax,kkn)      = SUM(mcc, SAMG(tmmtax,mcc,kkn)) ;

 SAMG("ggovt",tmsstax,kkn)     = SUM(mcc, SAMG(tmsstax,mcc,kkn)) ;

 SAMG("ggovt",teetax,kkn)      = SUM(dcc,SAMG(teetax,dcc,kkn)) ;

 SAMG("ggovt","vvattax",kkn)   = SUM(mcc,SAMG("vvattax",mcc,kkn))
                               + SUM(dcc,SAMG("vvattax",dcc,kkn)) ;

 SAMG("ggovt","ssaltax",kkn)   = SUM(mcc,SAMG("ssaltax",mcc,kkn))
                               + SUM(dcc,SAMG("ssaltax",dcc,kkn)) ;

 SAMG("ggovt",fftax,kkn)       = SUM(aa,SAMG(fftax,aa,kkn)) ;

 SAMG("ggovt","pprodtax",kkn)  = SUM(aa,SAMG("pprodtax",aa,kkn)) ;

* Government income for direct taxes

 SAMG("ggovt","ddirtax",kkn)   = SUM(ff,SAMG("ddirtax",ff,kkn))
                                + SAMG("ddirtax","hhous",kkn) ;

* Domestic Savings (14:5)
* Defining Savings by HOUS as total household income LESS
* Consumption expenditure and direct taxes

Parameter
 YH(kk)      Household income
 EH(kk)      Household expenditure ;


 YH(kkn)     =  SUM(ff,SAMG("hhous",ff,kkn)) ;
 EH(kkn)     =  SUM(mcc,SAMG(mcc,"hhous",kkn))
                + SUM(dcc,SAMG(dcc,"hhous",kkn))
                + SAMG("ddirtax","hhous",kkn) ;

*Display YH, EH ;

 SAMG("kkap","hhous",kkn)     = SUM(ff,SAMG("hhous",ff,kkn))
                               - SUM(mcc,SAMG(mcc,"hhous",kkn))
                               - SUM(dcc,SAMG(dcc,"hhous",kkn))
                               - SAMG("ddirtax","hhous",kkn) ;


* Government Savings (?:?)
* Defining Savings by Govt as total investment expenditure LESS
* Depreciation, External balance on margins trade and commodity trade,
* and household savings

 SAMG("kkap","ggovt",kkn)     =  SAMG("ttotal","kkap",kkn)
                               - SUM(ff,SAMG("kkap",ff,kkn))
                               - SUM(vsttmarg,SAMG("kkap",vsttmarg,kkn))
                               - SUM(ww,SAMG("kkap",ww,kkn))
                               - SAMG("kkap","hhous",kkn) ;

* Deleting savings by REG HOUSE

 SAMG("kkap","rreghous",kkn)  = 0.0 ;

* Defining HOUSE Income tax as HOUS Income less commodity expenditure and
* Savings by HOUSE

 SAMG("ggovt","rreghous",kkn)  = 0.0 ;

*--- Introducing the globe region for margins

* Exports of margins to globe
 SAMG(dcc,"wwglo",kkn)   = SUM(vsttmarg,SAMG(dcc,vsttmarg,kkn)) ;

 SAMG(dcc,vsttmarg,kkn)  = 0.0 ;

* Calculating the import demand for each margin import

 SAMG("wwglo",otppmarg,kkn)  = SUM(mcc,SAMG(otppmarg,mcc,kkn)) ;
 SAMG("wwglo",wtppmarg,kkn)  = SUM(mcc,SAMG(wtppmarg,mcc,kkn)) ;
 SAMG("wwglo",atppmarg,kkn)  = SUM(mcc,SAMG(atppmarg,mcc,kkn)) ;

 SAMG(vsttmarg,otppmarg,kkn) = 0.0 ;
 SAMG(vsttmarg,wtppmarg,kkn) = 0.0 ;
 SAMG(vsttmarg,atppmarg,kkn) = 0.0 ;

* Calculating trade balances for margins

 SAMG("kkap","wwglo",kkn)   = (SUM(otppmarg,SAMG("wwglo",otppmarg,kkn))
                               + SUM(wtppmarg,SAMG("wwglo",wtppmarg,kkn))
                               + SUM(atppmarg,SAMG("wwglo",atppmarg,kkn)))
                              - SUM(dcc,SAMG(dcc,"wwglo",kkn)) ;

 SAMG("kkap",vsttmarg,kkn)  = 0.0 ;

*#### Rounding the Global SAM to 6 Decimal Places
* The GTAP database only records data to 6 decimal places

 SAMG(ss,ssp,kk)      = ROUND(SAMG(ss,ssp,kk),roundpar) ;


*---- Populating the SAM for globe

Parameter
 SAM_glo(ss,ss)                   SAM for globe

 marg_exp(dcc,ww,kk)              Margin exports

 marg_imp_otp(otppmarg,mcc,kk)    OTP margin imports by kk
 marg_imp_wtp(wtppmarg,mcc,kk)    WTP margin imports by kk
 marg_imp_atp(atppmarg,mcc,kk)    ATP margin imports by kk

 margimps(mcc,kk)    Margin imports of type mcc by region kk

 ;

 marg_exp(dcc,ww,kkn)             = SAMG(dcc,"wwglo",kkn) ;

 marg_imp_otp(otppmarg,mcc,kkn)   = SAMG(otppmarg,mcc,kkn) ;
 marg_imp_wtp(wtppmarg,mcc,kkn)   = SAMG(wtppmarg,mcc,kkn) ;
 marg_imp_atp(atppmarg,mcc,kkn)   = SAMG(atppmarg,mcc,kkn) ;

*--- Clearing out any data in globe region

 SAMG(ss,ssp,"glo")     = 0.0 ;

 SAM_glo(ss,ssp)        = SAMG(ss,ssp,"glo") ;

Display SAM_glo, marg_imp_otp, marg_imp_wtp, marg_imp_atp ;

*--- Margin imports by globe (are exports dcc from other regions kkn to wwglo)

 SAMG(ww,mcc,"glo")     = SUM((dcc,kkn)
                            $(map_mcc_dcc(mcc,dcc)
                            $map_ww_kk(ww,kkn)),SAMG(dcc,"wwglo",kkn)) ;

Parameter

 margchk1(ss)      Margins check for margin imports by GLOBE

 ;

 margchk1(mcc)   = SUM((dcc,kkn)$map_mcc_dcc(mcc,dcc),marg_exp(dcc,"wwglo",kkn))
                       - SUM(ww,SAMG(ww,mcc,"glo")) ;

 SAM_glo(ww,mcc)  = SAMG(ww,mcc,"glo") ;

DISPLAY SAM_glo, margchk1 ;

*--- Margin exports by globe (are imports o/w/atp by other regions kkn to wwglo)

* Margin imports by Region

 margimps("mmotp",kk)  = SUM((otppmarg,mcc),SAMG(otppmarg,mcc,kk)) ;
 margimps("mmwtp",kk)  = SUM((wtppmarg,mcc),SAMG(wtppmarg,mcc,kk)) ;
 margimps("mmatp",kk)  = SUM((atppmarg,mcc),SAMG(atppmarg,mcc,kk)) ;

DISPLAY margimps ;

Execute_unload 'marg_test.gdx', margimps,
                                SAM_glo,
                                marg_imp_otp,
                                marg_imp_wtp,
                                marg_imp_atp
   ;


 SAMG(dcc,ww,"glo")    = SUM((mcc,kkn)
                          $(map_ww_kk(ww,kkn)
                          $map_dcc_mcc(dcc,mcc)),margimps(mcc,kkn)) ;

 SAM_glo(dcc,ww)  = SAMG(dcc,ww,"glo") ;

 SAMG("ddotp","mmotp","glo") = -1 * SUM(ww,SAMG("ddotp",ww,"glo")) ;
 SAMG("ddwtp","mmwtp","glo") = -1 * SUM(ww,SAMG("ddwtp",ww,"glo")) ;
 SAMG("ddatp","mmatp","glo") = -1 * SUM(ww,SAMG("ddatp",ww,"glo")) ;

 SAMG("kkap",ww,"glo") = SUM(mcc,SAMG(ww,mcc,"glo"))
                          - SUM(dcc,SAMG(dcc,ww,"glo")) ;

 SAM_glo("kkap",ww)  = SAMG("kkap",ww,"glo") ;

 SAM_glo("TTOTAL",ssnp)        = SUM(ssn,SAM_glo(ssn,ssnp)) ;
 SAM_glo(ssn,"TTOTAL")         = SUM(ssnp,SAM_glo(ssn,ssnp)) ;

Parameter
 diff_SAM_glo(ss)    differences in SAM_glo row and column totals
 ;

 diff_SAM_glo(ssn)  = SAM_glo("TTOTAL",ssn) - SAM_glo(ssn,"TTOTAL") ;

Display SAM_glo, diff_SAM_glo ;

Execute_unload 'samg_glo1.gdx', SAM_glo ;

*---- Removing the 'Errors' in Margins

* Recomputing the account totals

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Parameter
 adjust_m(ss,kk)   Adjustment for trade margins
 COLTOT(ss,kk)     Column total
 ROWTOT(kk,ss)     Row totals
 ;

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 adjust_m(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 adjust_m(ssnp,kk)   = ROUND(adjust_m(ssnp,kk),roundpar ) ;

Display adjust_m ;

*--- Adjusting trade margins through USA accounts

* Adjust for globe

 SAMG("wwusa","mmotp","glo") = SAMG("wwusa","mmotp","glo") - adjust_m("mmotp","glo") ;
 SAMG("wwusa","mmwtp","glo") = SAMG("wwusa","mmwtp","glo") - adjust_m("mmwtp","glo") ;
 SAMG("wwusa","mmatp","glo") = SAMG("wwusa","mmatp","glo") - adjust_m("mmatp","glo") ;

 SAMG("kkap",ww,"glo") = SUM(mcc,SAMG(ww,mcc,"glo"))
                          - SUM(dcc,SAMG(dcc,ww,"glo")) ;

 SAM_glo("kkap",ww)  = SAMG("kkap",ww,"glo") ;

* Adjust for USA

 SAMG("ddotp","wwglo","usa") = SAMG("ddotp","wwglo","usa") - adjust_m("mmotp","glo") ;
 SAMG("ddwtp","wwglo","usa") = SAMG("ddwtp","wwglo","usa") - adjust_m("mmwtp","glo") ;
 SAMG("ddatp","wwglo","usa") = SAMG("ddatp","wwglo","usa") - adjust_m("mmatp","glo") ;

 SAMG("ssaltax","ddotp","usa") = SAMG("ssaltax","ddotp","usa") - adjust_m("mmotp","glo") ;
 SAMG("ssaltax","ddwtp","usa") = SAMG("ssaltax","ddwtp","usa") - adjust_m("mmwtp","glo") ;
 SAMG("ssaltax","ddatp","usa") = SAMG("ssaltax","ddatp","usa") - adjust_m("mmatp","glo") ;

 SAMG("ggovt","ssaltax","usa")  = SUM(mcc,SAMG("ssaltax",mcc,"usa"))
                                 + SUM(dcc,SAMG("ssaltax",dcc,"usa")) ;

 SAMG("kkap","ggovt","usa")   = SAMG("kkap","ggovt","usa")
                                - adjust_m("mmotp","glo")
                                - adjust_m("mmwtp","glo")
                                - adjust_m("mmatp","glo") ;

 SAMG("kkap","wwglo","usa")   = SAMG("kkap","wwglo","usa")
                                + adjust_m("mmotp","glo")
                                + adjust_m("mmwtp","glo")
                                + adjust_m("mmatp","glo") ;

 SAM_glo(ss,ssp)  = SAMG(ss,ssp,"glo") ;

 SAM_glo("TTOTAL",ssnp)        = SUM(ssn,SAM_glo(ssn,ssnp)) ;
 SAM_glo(ssn,"TTOTAL")         = SUM(ssnp,SAM_glo(ssn,ssnp)) ;

 diff_SAM_glo(ssn)  = SAM_glo("TTOTAL",ssn) - SAM_glo(ssn,"TTOTAL") ;

Display diff_SAM_glo ;

Execute_unload 'samg_glo2.gdx', SAM_glo ;

*------ Balancing and Checking the Global SAM --------------------

Parameter
 COLTOT_G(*,kk)       Check on region column totals
 ROWTOT_G(kk,*)       Check on region row totals

 DIFFTOT_G(*,kk)      Check on difference in region column and row totals
 SUMDIFFTOT_G(kk)     Sum of differences in region row and column totals

 CNTDIFFTOT_G5(kk)    Count of diffs in row and column total at 5 decimal places
 CNTDIFFTOT_G4(kk)    Count of diffs in row and column total at 4 decimal places
 CNTDIFFTOT_G3(kk)    Count of diffs in row and column total at 3 decimal places
 CNTDIFFTOT_G2(kk)    Count of diffs in row and column total at 2 decimal places
 CNTDIFFTOT_G1(kk)    Count of diffs in row and column total at 1 decimal places

 DIFFPER_G(*,kk)      Percent differences in region column and row totals
 CNTDIFFPER_G(kk)     Count of large Percent differences column and row totals

 ;

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 COLTOT_G(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT_G(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT_G(ssnp,kk)   = COLTOT_G(ssnp,kk) - ROWTOT_G(kk,ssnp) ;

 DIFFTOT_G(ssnp,kk)   = ROUND(DIFFTOT_G(ssnp,kk),roundpar ) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.00001)) = 0.0 ;
 CNTDIFFTOT_G5(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_G4(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_G3(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.001)) = 0.0 ;
 CNTDIFFTOT_G2(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.01)) = 0.0 ;
 CNTDIFFTOT_G1(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 SUMDIFFTOT_G(kk)     = SUM(ssnp,DIFFTOT_G(ssnp,kk)) ;

 DIFFPER_G(ssnp,kk)$(COLTOT_G(ssnp,kk)+ ROWTOT_G(kk,ssnp))
      = (DIFFTOT_G(ssnp,kk)/(0.5 * (COLTOT_G(ssnp,kk)
                                    + ROWTOT_G(kk,ssnp)))) * 100 ;

 DIFFPER_G(ssnp,kk)   = ROUND(DIFFPER_G(ssnp,kk),roundpar ) ;

 DIFFPER_G(ssnp,kk)$(ABS(DIFFPER_G(ssnp,kk) lt 0.01)) = 0.0 ;

 CNTDIFFPER_G(kk)  = SUM(ssn$DIFFPER_G(ssn,kk), 1) ;

option decimals = 8 ;

DISPLAY COLTOT_G, ROWTOT_G,
        DIFFTOT_G, CNTDIFFTOT_G5, CNTDIFFTOT_G4, CNTDIFFTOT_G3,
        CNTDIFFTOT_G2, CNTDIFFTOT_G1, SUMDIFFTOT_G,
        DIFFPER_G, CNTDIFFPER_G ;

*---- Removing the 'Errors' in SAMG

$ontext
 Check that the 'errors' are small before corrying out this step
$offtext

* Recomputing the account totals

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Parameter
 adjust_g(ss,kk)   Adjustment for marginal inbalances in SAMG
 ;

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 adjust_g(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 adjust_g(ssnp,kk)   = ROUND(adjust_g(ssnp,kk),roundpar) ;

Display adjust_g ;

* Import commodity accounts

 SAMG("ssaltax",mcc,kk)  = SAMG("ssaltax",mcc,kk) - adjust_g(mcc,kk) ;

 SAMG("ggovt","ssaltax",kk) = SUM(mcc,SAMG("ssaltax",mcc,kk))
                              + SUM(dcc,SAMG("ssaltax",dcc,kk)) ;



*------ Re Checking the Global SAM --------------------

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 COLTOT_G(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT_G(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT_G(ssnp,kk)   = COLTOT_G(ssnp,kk) - ROWTOT_G(kk,ssnp) ;

 DIFFTOT_G(ssnp,kk)   = ROUND(DIFFTOT_G(ssnp,kk),roundpar ) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.00001)) = 0.0 ;
 CNTDIFFTOT_G5(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_G4(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_G3(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.001)) = 0.0 ;
 CNTDIFFTOT_G2(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 DIFFTOT_G(ssnp,kk)$(ABS(DIFFTOT_G(ssnp,kk) lt 0.01)) = 0.0 ;
 CNTDIFFTOT_G1(kk)  = SUM(ssn$DIFFTOT_G(ssn,kk), 1) ;

 SUMDIFFTOT_G(kk)     = SUM(ssnp,DIFFTOT_G(ssnp,kk)) ;

 DIFFPER_G(ssnp,kk)$(COLTOT_G(ssnp,kk)+ ROWTOT_G(kk,ssnp))
      = (DIFFTOT_G(ssnp,kk)/(0.5 * (COLTOT_G(ssnp,kk)
                                    + ROWTOT_G(kk,ssnp)))) * 100 ;

 DIFFPER_G(ssnp,kk)   = ROUND(DIFFPER_G(ssnp,kk),roundpar ) ;

 DIFFPER_G(ssnp,kk)$(ABS(DIFFPER_G(ssnp,kk) lt 0.01)) = 0.0 ;

 CNTDIFFPER_G(kk)  = SUM(ssn$DIFFPER_G(ssn,kk), 1) ;

option decimals = 8 ;

DISPLAY COLTOT_G, ROWTOT_G,
        DIFFTOT_G, CNTDIFFTOT_G5, CNTDIFFTOT_G4, CNTDIFFTOT_G3,
        CNTDIFFTOT_G2, CNTDIFFTOT_G1, SUMDIFFTOT_G,
        DIFFPER_G, CNTDIFFPER_G ;

*############## 10. GENERATING SAMG_M ####################################

Parameter
 SAMG_M(ss,ssp,kk)    SAMG with separate import accounts ;

 SAMG_M(ss,ssp,kk)    = SAMG(ss,ssp,kk) ;

*----- CHECKING GLOBAL SAMG_M

* This checking of the Global SAM is important.

*#### Computing Account totals for SAMG_M by Region

 SAMG_M("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG_M(ssn,ssnp,kk)) ;

 SAMG_M(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG_M(ssn,ssnp,kk)) ;

Parameter
 COLTOT_M(*,kk)       Check on region column totals
 ROWTOT_M(kk,*)       Check on region row totals

 DIFFTOT_M(*,kk)      Check on difference in region column and row totals
 SUMDIFFTOT_M(kk)     Sum of differences in region row and column totals

 CNTDIFFTOT_M5(kk)    Count of diffs in row and column total at 5 decimal places
 CNTDIFFTOT_M4(kk)    Count of diffs in row and column total at 4 decimal places
 CNTDIFFTOT_M3(kk)    Count of diffs in row and column total at 3 decimal places
 CNTDIFFTOT_M2(kk)    Count of diffs in row and column total at 2 decimal places
 CNTDIFFTOT_M1(kk)    Count of diffs in row and column total at 1 decimal places

 DIFFPER_M(*,kk)      Percent differences in region column and row totals
 CNTDIFFPER_M(kk)     Count of large Percent differences column and row totals
 ;

 COLTOT_M(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT_M(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT_M(ssnp,kk)   = COLTOT_M(ssnp,kk) - ROWTOT_M(kk,ssnp) ;

 DIFFTOT_M(ssnp,kk)   = ROUND(DIFFTOT_M(ssnp,kk),roundpar ) ;

 DIFFTOT_M(ssnp,kk)$(ABS(DIFFTOT_M(ssnp,kk) lt 0.00001)) = 0.0 ;
 CNTDIFFTOT_M5(kk)  = SUM(ssn$DIFFTOT_M(ssn,kk), 1) ;

 DIFFTOT_M(ssnp,kk)$(ABS(DIFFTOT_M(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_M4(kk)  = SUM(ssn$DIFFTOT_M(ssn,kk), 1) ;

 DIFFTOT_M(ssnp,kk)$(ABS(DIFFTOT_M(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_M3(kk)  = SUM(ssn$DIFFTOT_M(ssn,kk), 1) ;

 DIFFTOT_M(ssnp,kk)$(ABS(DIFFTOT_M(ssnp,kk) lt 0.001)) = 0.0 ;
 CNTDIFFTOT_M2(kk)  = SUM(ssn$DIFFTOT_M(ssn,kk), 1) ;

 DIFFTOT_M(ssnp,kk)$(ABS(DIFFTOT_M(ssnp,kk) lt 0.01)) = 0.0 ;
 CNTDIFFTOT_M1(kk)  = SUM(ssn$DIFFTOT_M(ssn,kk), 1) ;

 SUMDIFFTOT_M(kk)     = SUM(ssnp,DIFFTOT_M(ssnp,kk)) ;

 DIFFPER_M(ssnp,kk)$(COLTOT_M(ssnp,kk)+ROWTOT_M(kk,ssnp))
      = (DIFFTOT_M(ssnp,kk)/(0.5 * (COLTOT_M(ssnp,kk)
                                    + ROWTOT_M(kk,ssnp)))) * 100 ;

 DIFFPER_M(ssnp,kk)   = ROUND(DIFFPER_M(ssnp,kk),roundpar ) ;

 DIFFPER_M(ssnp,kk)$(ABS(DIFFPER_M(ssnp,kk) lt 0.01)) = 0.0 ;

 CNTDIFFPER_M(kk)  = SUM(ssn$DIFFPER_M(ssn,kk), 1) ;

option decimals = 8 ;

DISPLAY COLTOT_M, ROWTOT_M,
        DIFFTOT_M, CNTDIFFTOT_M5, CNTDIFFTOT_M4, CNTDIFFTOT_M3,
        CNTDIFFTOT_M2, CNTDIFFTOT_M1, SUMDIFFTOT_M,
        DIFFPER_M, CNTDIFFPER_M
 ;

*## Writing out the CHECK results to GDX

IF(OUTGDXv_M = 1,

Execute_Unload  'samg_m_8107_chk.gdx',
                                         COLTOT_M
                                         ROWTOT_M
                                         DIFFTOT_M
                                         DIFFPER_M
                                         SUMDIFFTOT_M
  ;

  ) ;

Execute_unload 'samg_m.gdx', SAMG_M
* Factor based
                             FacSubs
                             FacEmpTax
* Activity based
                             OutSubs
* Intermediate Input based
                             IntInSubsM
                             IntInSubsD
* Export based
                             MFASubs
                             OrdXSub
* Import based
                             OrdMDuty
* GTAP Elasticities
                             ESUBVA
                             ESUBD
                             ESUBM
* GTAP Energy Volumes
                             EVolDA
                             EVolDH
                             EVolDG
                             EVolDI
                             EVolIA
                             EVolIH
                             EVolIG
                             EVolII
                             EVolT
* GTAP Population data
                             POPn
* GTAP Capital Stock Trade data
                             Kstoc
* GTAP Time Series Trade data
                             TSTRAD

 ;

*############## 10. GENERATING SAMG_GLB ####################################

$ontext

This stage creates a SAM under the implicit assumption that a law of
one price held in the base GTAP data.

The imported and domestic commodity accounts are aggregated to follow a
composite commodity type model - see McDonald & Thierfelder (2008)
for an example of this type of representation.

$offtext

*--- Commodity demand aggregation
* Intermediate inputs
 SAMG(cc,aa,kkn)         = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(mcc,aa,kkn))
                          + SUM(dcc$map_cc_dcc(cc,dcc),SAMG(dcc,aa,kkn)) ;

 SAMG(mcc,aa,kkn)        = 0.0 ;
 SAMG(dcc,aa,kkn)        = 0.0 ;

* Final demand
 SAMG(cc,inst,kkn)    = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(mcc,inst,kkn))
                          + SUM(dcc$map_cc_dcc(cc,dcc),SAMG(dcc,inst,kkn)) ;

 SAMG(mcc,inst,kkn)   = 0.0 ;
 SAMG(dcc,inst,kkn)   = 0.0 ;

* SAMG(cc,vsttmarg,kkn)   = SUM(dcc$map_cc_dcc(cc,dcc),SAMG(dcc,vsttmarg,kkn)) ;

* SAMG(mcc,vsttmarg,kkn)  = 0.0 ;
* SAMG(dcc,vsttmarg,kkn)  = 0.0 ;

* Exports
 SAMG(cc,ww,kkn)         = SUM(dcc$map_cc_dcc(cc,dcc),SAMG(dcc,ww,kkn)) ;

 SAMG(mcc,ww,kkn)        = 0.0 ;
 SAMG(dcc,ww,kkn)        = 0.0 ;

*--- Commodity Supply accounts

* Supply Matrix
 SAMG(aa,cc,kkn)         = SUM(dcc$map_cc_dcc(cc,dcc),SAMG(aa,dcc,kkn)) ;

 SAMG(aa,dcc,kkn)        = 0.0 ;

*-- Tax Accounts
* Import duties
 SAMG(tmmtax,cc,kkn)     = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(tmmtax,mcc,kkn)) ;

 SAMG(tmmtax,mcc,kkn)    = 0.0 ;

 SAMG(tmsstax,cc,kkn)    = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(tmsstax,mcc,kkn)) ;

 SAMG(tmsstax,mcc,kkn)   = 0.0 ;

 SAMG(teetax,cc,kkn)     = SUM(dcc$map_cc_dcc(cc,dcc),SAMG(teetax,dcc,kkn)) ;

* Export taxes
 SAMG(teetax,mcc,kkn)    = 0.0 ;
 SAMG(teetax,dcc,kkn)    = 0.0 ;

* Commodity Taxes
 SAMG("vvattax",cc,kkn)  = SUM(mcc$map_cc_mcc(cc,mcc),SAMG("vvattax",mcc,kkn))
                          + SUM(dcc$map_cc_dcc(cc,dcc),SAMG("vvattax",dcc,kkn)) ;

 SAMG("vvattax",mcc,kkn) = 0.0 ;
 SAMG("vvattax",dcc,kkn) = 0.0 ;

 SAMG("ssaltax",cc,kkn)  = SUM(mcc$map_cc_mcc(cc,mcc),SAMG("ssaltax",mcc,kkn))
                          + SUM(dcc$map_cc_dcc(cc,dcc),SAMG("ssaltax",dcc,kkn)) ;

 SAMG("ssaltax",mcc,kkn) = 0.0 ;
 SAMG("ssaltax",dcc,kkn) = 0.0 ;

*-- Import margins
 SAMG(otppmarg,cc,kkn)   = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(otppmarg,mcc,kkn)) ;

 SAMG(otppmarg,mcc,kkn)  = 0.0 ;

 SAMG(wtppmarg,cc,kkn)   = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(wtppmarg,mcc,kkn)) ;

 SAMG(wtppmarg,mcc,kkn)  = 0.0 ;

 SAMG(atppmarg,cc,kkn)   = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(atppmarg,mcc,kkn)) ;

 SAMG(atppmarg,mcc,kkn)  = 0.0 ;

* Imports
 SAMG(ww,cc,kkn)         = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(ww,mcc,kkn)) ;

 SAMG(ww,mcc,kkn)        = 0.0 ;

*#### Rounding the Global SAM to 6 Decimal Places
* The GTAP database only records data to 6 decimal places

 SAMG(ss,ssp,kk)      = ROUND(SAMG(ss,ssp,kk),roundpar) ;


*---- Generating the SAM for the Globe region

$ontext

This stage allocates expenditures and incomes to the GLOBE region.

$offtext

 SAMG(dcc,mcc,"glo")       = 0.0 ;

* Exports

 SAMG(cc,ww,"glo")         = SUM(dcc$map_cc_dcc(cc,dcc),SAMG(dcc,ww,"glo")) ;

 SAMG(dcc,ww,"glo")        = 0.0 ;

* Imports

 SAMG(ww,cc,"glo")         = SUM(mcc$map_cc_mcc(cc,mcc),SAMG(ww,mcc,"glo")) ;

 SAMG(ww,mcc,"glo")        = 0.0 ;

* globe trade balance

 SAMG("kkap",ww,"glo") = 0.0 ;

 SAMG("kkap",ww,"glo") = SUM(cc,SAMG(ww,cc,"glo"))
                          - SUM(cc,SAMG(cc,ww,"glo")) ;


*#### Computing Account totals for GLOBE SAM

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Parameter
 COLTOT_glo(ss)       Check on region column totals
 ROWTOT_glo(ss)       Check on region row totals
 DIFFTOT_glo(ss)      Check on difference in region column and row totals
 ;

 COLTOT_glo(ssnp)    = SUM(ssn,SAMG(ssn,ssnp,"glo")) ;
 ROWTOT_glo(ssn)     = SUM(ssnp,SAMG(ssn,ssnp,"glo")) ;

 DIFFTOT_glo(ssnp)   = COLTOT_glo(ssnp) - ROWTOT_glo(ssnp) ;

 DIFFTOT_glo(ssnp)   = ROUND(DIFFTOT_glo(ssnp),roundpar ) ;

Display COLTOT_glo, ROWTOT_glo, DIFFTOT_glo ;


 SAM_glo(ss,ssp) = SAMG(ss,ssp,"glo") ;

Execute_unload 'glob_test.gdx', SAM_glo ;

Display SAM_glo ;


*############## 7. CHECKING THE NEW GLOBAL SAMG ########################

* This checking of the Global SAM is important.

*#### Computing Account totals for Global SAM by Region

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Parameter
 COLTOT_glb(*,kk)       Check on region column totals
 ROWTOT_glb(kk,*)       Check on region row totals

 DIFFTOT_glb(*,kk)      Check on difference in region column and row totals
 SUMDIFFTOT_glb(kk)     Sum of differences in region row and column totals

 CNTDIFFTOT_glb5(kk)    Count of diffs in row and column total at 5 decimal places
 CNTDIFFTOT_glb4(kk)    Count of diffs in row and column total at 4 decimal places
 CNTDIFFTOT_glb3(kk)    Count of diffs in row and column total at 3 decimal places
 CNTDIFFTOT_glb2(kk)    Count of diffs in row and column total at 2 decimal places
 CNTDIFFTOT_glb1(kk)    Count of diffs in row and column total at 1 decimal places

 DIFFPER_glb(*,kk)      Percent differences in region column and row totals
 CNTDIFFPER_glb(kk)     Count of large Percent differences column and row totals

 ;

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 COLTOT_glb(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT_glb(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT_glb(ssnp,kk)   = COLTOT_glb(ssnp,kk) - ROWTOT_glb(kk,ssnp) ;

 DIFFTOT_glb(ssnp,kk)   = ROUND(DIFFTOT_glb(ssnp,kk),roundpar ) ;

 DIFFTOT_glb(ssnp,kk)$(ABS(DIFFTOT_glb(ssnp,kk) lt 0.00001)) = 0.0 ;
 CNTDIFFTOT_glb5(kk)  = SUM(ssn$DIFFTOT_glb(ssn,kk), 1) ;

 DIFFTOT_glb(ssnp,kk)$(ABS(DIFFTOT_glb(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_glb4(kk)  = SUM(ssn$DIFFTOT_glb(ssn,kk), 1) ;

 DIFFTOT_glb(ssnp,kk)$(ABS(DIFFTOT_glb(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_glb3(kk)  = SUM(ssn$DIFFTOT_glb(ssn,kk), 1) ;

 DIFFTOT_glb(ssnp,kk)$(ABS(DIFFTOT_glb(ssnp,kk) lt 0.001)) = 0.0 ;
 CNTDIFFTOT_glb2(kk)  = SUM(ssn$DIFFTOT_glb(ssn,kk), 1) ;

 DIFFTOT_glb(ssnp,kk)$(ABS(DIFFTOT_glb(ssnp,kk) lt 0.01)) = 0.0 ;
 CNTDIFFTOT_glb1(kk)  = SUM(ssn$DIFFTOT_glb(ssn,kk), 1) ;

 SUMDIFFTOT_glb(kk)     = SUM(ssnp,DIFFTOT_glb(ssnp,kk)) ;

 DIFFPER_glb(ssnp,kk)$(COLTOT_glb(ssnp,kk)+ ROWTOT_glb(kk,ssnp))
      = (DIFFTOT_glb(ssnp,kk)/(0.5 * (COLTOT_glb(ssnp,kk)
                                    + ROWTOT_glb(kk,ssnp)))) * 100 ;

 DIFFPER_glb(ssnp,kk)   = ROUND(DIFFPER_glb(ssnp,kk),roundpar ) ;

 DIFFPER_glb(ssnp,kk)$(ABS(DIFFPER_glb(ssnp,kk) lt 0.01)) = 0.0 ;

 CNTDIFFPER_glb(kk)  = SUM(ssn$DIFFPER_glb(ssn,kk), 1) ;

option decimals = 8 ;

DISPLAY COLTOT_glb, ROWTOT_glb,
        DIFFTOT_glb, CNTDIFFTOT_glb5, CNTDIFFTOT_glb4, CNTDIFFTOT_glb3,
        CNTDIFFTOT_glb2, CNTDIFFTOT_glb1, SUMDIFFTOT_glb,
        DIFFPER_glb, CNTDIFFPER_glb ;


*## Writing out the CHECK results to GDX

*IF(OUTGDXv3g = 1,

Execute_Unload  'globsam8107_GLB_chk.gdx',
                                         COLTOT_glb
                                         ROWTOT_glb
                                         DIFFTOT_glb
                                         DIFFPER_glb
                                         SUMDIFFTOT_glb
  ;

*  ) ;


*############## 8. ORGANISING ADDITIONAL GTAP DATA #######################
* ### Relabelling additional data parameters where necessary

Parameter
* GTAP Elasticities
 ESUBD2(cc)          Armington CES for domestic_imported allocation
 ESUBM2(cc)          Armington CES for regional allocation of imports

* GTAP Energy Volumes

 EVol2(cc,ss,kk)     volume of energy input purchases (Mtoe)
 EVolT2(cc,kk,kk)    volume of bilateral trade (Mtoe)

* Activity based
 OutSubs2(cc,kk)         Ordinary Output Subsidies

* Intermediate Input based
 IntInSubsM2(cc,aa,kk)  Imported intermediate input subsidies
 IntInSubsD2(cc,aa,kk)  Domestic intermediate input subsidies

* Export based
 MFASubs2(cc,ww,kk)     MFA Export Subsidy Equivalents
 OrdXSub2(cc,ww,kk)     Ordinary Export subsidies

* Import based
 OrdMDuty2(ww,cc,kk)    Ordinary Import duties

  ;

* GTAP Elasticities
 ESUBD2(cc)        = SUM(mcc$map_cc_mcc(cc,mcc),ESUBD(mcc)) ;

 ESUBM2(cc)        = SUM(mcc$map_cc_mcc(cc,mcc),ESUBM(mcc)) ;

* GTAP Energy Volumes

 EVol2(cc,aa,kk)  = SUM(en$map_cc_en(cc,en),EVolDA(en,aa,kk))
                     + SUM(en$map_cc_en(cc,en),EVolIA(en,aa,kk)) ;

 EVol2(cc,"hhous",kk)  = SUM(en$map_cc_en(cc,en),EVolDH(en,kk))
                     + SUM(en$map_cc_en(cc,en),EVolIH(en,kk)) ;

 EVol2(cc,"ggovt",kk)  = SUM(en$map_cc_en(cc,en),EVolDG(en,kk))
                     + SUM(en$map_cc_en(cc,en),EVolIG(en,kk)) ;

 EVol2(cc,"kkap",kk)  = SUM(en$map_cc_en(cc,en),EVolDI(en,kk))
                     + SUM(en$map_cc_en(cc,en),EVolII(en,kk)) ;


 EVolT2(cc,kk,kk)     =  SUM(en$map_cc_en(cc,en),EVolT(en,kk,kk)) ;


DISPLAY EVol2, EVolT2 ;

* ### Relabelling times series trade data

Parameter
* GTAP Time Series Trade data

 TSTRAD2(cc,kk,ww,tt) Time series of trade flows between regions

  ;

 TSTRAD2(cc,kk,ww,tt)  = SUM(dcc$map_cc_dcc(cc,dcc),TSTRAD(dcc,kk,ww,tt)) ;

* Activity based
 OutSubs2(cc,kk)        = SUM(dcc
                          $map_cc_dcc(cc,dcc),OutSubs(dcc,kk)) ;

* Intermediate Input based
 IntInSubsM2(cc,aa,kk)  =  SUM(mcc
                         $map_cc_mcc(cc,mcc),IntInSubsM(mcc,aa,kk)) ;

 IntInSubsD2(cc,aa,kk)  = SUM(dcc
                          $map_cc_dcc(cc,dcc),IntInSubsD(dcc,aa,kk)) ;

* Export based
 MFASubs2(cc,ww,kk)     = SUM(dcc
                          $map_cc_dcc(cc,dcc),MFASubs(dcc,ww,kk)) ;

 OrdXSub2(cc,ww,kk)     = SUM(dcc
                          $map_cc_dcc(cc,dcc),OrdXSub(dcc,ww,kk)) ;

* Import based
 OrdMDuty2(ww,cc,kk)    = SUM(mcc
                           $map_cc_mcc(cc,mcc),OrdMDuty(ww,mcc,kk)) ;

*############## 12. WRITING THE GLOBAL SAM FOR GLB2 TO GDX ###############

*## Writing out the GTAP NEW SAM to GDX

IF(OUTGDXv3g = 1,

* This writes all the SAM data to GDX
Execute_Unload  'globsam8107_GLBv2.gdx', SAMG
* GTAP Elasticity Values
                                   ESUBVA,
                                   ESUBD2,
                                   ESUBM2,
* Sales Taxes
                                   SMTAX,
                                   SDTAX,
                                   STAX,
* GTAP Energy Volumes
                                   EVol2,
                                   EVolT2,
* Factor based
                                   FacSubs,
                                   FacEmpTax,
* Activity based
                                   OutSubs2,
* Intermediate Input based
                                   IntInSubsM2,
                                   IntInSubsD2,
* Export based
                                   MFASubs2,
                                   OrdXSub2,
* Import based
                                   OrdMDuty2,
* GTAP population data
                                   Popn,
* GTAP Capital Stock Trade data
                                   Kstoc,
* GTAP Time series trade data
                                   TSTRAD2

  ;

   )  ;

*################# ENERGY DATA VARIANT FOR GLB2 ##########################
Parameter

 SAMG_en(ss,ss,kk)    SAMG with energy taxes
 STAX_en(cc,ss,kk)    energy sales tax revenues by agent

 ;

* Initial Assignment for SAMG_en

 SAMG_en(ss,ssp,kk)   = SAMG(ss,ssp,kk) ;

* Assigning energy component of sales taxes to STAX_en

 STAX_en(cceg,ss,kk)  = STAX(cceg,ss,kk) ;

Display STAX_en ;

*----- Redefining the valuation of purchases of energy commodities by agents

 SAMG_en(cceg,aa,kk)   = SAMG_en(cceg,aa,kk) - STAX_en(cceg,aa,kk) ;

 SAMG_en(cceg,inst,kk) = SAMG_en(cceg,inst,kk) - STAX_en(cceg,inst,kk) ;

*---- Defining sales tax transactions

 SAMG_en(sstax,aa,kk)    = SUM(cc$map_sstax_cc(sstax,cc),STAX_en(cc,aa,kk)) ;

 SAMG_en("ssaltax",cceg,kk) = 0.0 ;

 SAMG_en("ggovt","ssaltax",kk) = SUM(cc,SAMG_en("ssaltax",cc,kk)) ;

 SAMG_en(sstax,inst,kk)  = SUM(cc$map_sstax_cc(sstax,cc),STAX_en(cc,inst,kk)) ;

 SAMG_en("vvattax",cceg,kk) = 0.0 ;

 SAMG_en("ggovt","vvattax",kk) = SUM(cc,SAMG_en("vvattax",cc,kk)) ;

 SAMG_en("ggovt",sstax,kk)  = SUM(aa,SAMG_en(sstax,aa,kk))
                              + SUM(inst,SAMG_en(sstax,inst,kk)) ;

 SAMG_en("ggovt",tmmtax,kk)  = SUM(cc,SAMG_en(tmmtax,cc,kk)) ;
 SAMG_en("ggovt",tmsstax,kk) = SUM(cc,SAMG_en(tmsstax,cc,kk)) ;

Parameter
 COLTOT_en(*,kk)       Check on region column totals
 ROWTOT_en(kk,*)       Check on region row totals

 DIFFTOT_en(*,kk)      Check on difference in region column and row totals
 SUMDIFFTOT_en(kk)     Sum of differences in region row and column totals

 CNTDIFFTOT_en5(kk)    Count of diffs in row and column total at 5 decimal places
 CNTDIFFTOT_en4(kk)    Count of diffs in row and column total at 4 decimal places
 CNTDIFFTOT_en3(kk)    Count of diffs in row and column total at 3 decimal places
 CNTDIFFTOT_en2(kk)    Count of diffs in row and column total at 2 decimal places
 CNTDIFFTOT_en1(kk)    Count of diffs in row and column total at 1 decimal places

 DIFFPER_en(*,kk)      Percent differences in region column and row totals
 CNTDIFFPER_en(kk)     Count of large Percent differences column and row totals

 adjust_en(ss,kk)      Adjustment for energy taxes

 ;

*--- Adjustment

 SAMG_en("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG_en(ssn,ssnp,kk)) ;
 SAMG_en(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG_en(ssn,ssnp,kk)) ;

 COLTOT_en(ssnp,kk)    = SUM(ssn,SAMG_en(ssn,ssnp,kk)) ;
 ROWTOT_en(kk,ssn)     = SUM(ssnp,SAMG_en(ssn,ssnp,kk)) ;

 adjust_en(ssn,kk)     = COLTOT_en(ssn,kk) - ROWTOT_en(kk,ssn) ;

 adjust_en(ssn,kk)     = ROUND(adjust_en(ssn,kk),roundpar ) ;

Display adjust_en ;

 SAMG_en("ssaltax",cc,kk)     = SAMG_en("ssaltax",cc,kk) - adjust_en(cc,kk) ;

 SAMG_en("ggovt","ssaltax",kk) = SUM(cc,SAMG_en("ssaltax",cc,kk)) ;

*------- Checking Energy SAMG

 SAMG_en("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG_en(ssn,ssnp,kk)) ;
 SAMG_en(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG_en(ssn,ssnp,kk)) ;

 COLTOT_en(ssnp,kk)    = SUM(ssn,SAMG_en(ssn,ssnp,kk)) ;
 ROWTOT_en(kk,ssn)     = SUM(ssnp,SAMG_en(ssn,ssnp,kk)) ;

 DIFFTOT_en(ssnp,kk)   = COLTOT_en(ssnp,kk) - ROWTOT_en(kk,ssnp) ;

 DIFFTOT_en(ssnp,kk)   = ROUND(DIFFTOT_en(ssnp,kk),roundpar ) ;

Display DIFFTOT_en ;

 DIFFTOT_en(ssnp,kk)$(ABS(DIFFTOT_en(ssnp,kk) lt 0.00001)) = 0.0 ;
 CNTDIFFTOT_en5(kk)  = SUM(ssn$DIFFTOT_en(ssn,kk), 1) ;

Display DIFFTOT_en ;

 DIFFTOT_en(ssnp,kk)$(ABS(DIFFTOT_en(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_en4(kk)  = SUM(ssn$DIFFTOT_en(ssn,kk), 1) ;

Display DIFFTOT_en ;

 DIFFTOT_en(ssnp,kk)$(ABS(DIFFTOT_en(ssnp,kk) lt 0.0001)) = 0.0 ;
 CNTDIFFTOT_en3(kk)  = SUM(ssn$DIFFTOT_en(ssn,kk), 1) ;

Display DIFFTOT_en ;

 DIFFTOT_en(ssnp,kk)$(ABS(DIFFTOT_en(ssnp,kk) lt 0.001)) = 0.0 ;
 CNTDIFFTOT_en2(kk)  = SUM(ssn$DIFFTOT_en(ssn,kk), 1) ;

Display DIFFTOT_en ;

 DIFFTOT_en(ssnp,kk)$(ABS(DIFFTOT_en(ssnp,kk) lt 0.01)) = 0.0 ;
 CNTDIFFTOT_en1(kk)  = SUM(ssn$DIFFTOT_en(ssn,kk), 1) ;

 SUMDIFFTOT_en(kk)     = SUM(ssnp,DIFFTOT_en(ssnp,kk)) ;

 DIFFPER_en(ssnp,kk)$(COLTOT_en(ssnp,kk)+ ROWTOT_en(kk,ssnp))
      = (DIFFTOT_en(ssnp,kk)/(0.5 * (COLTOT_en(ssnp,kk)
                                    + ROWTOT_en(kk,ssnp)))) * 100 ;

 DIFFPER_en(ssnp,kk)   = ROUND(DIFFPER_en(ssnp,kk),roundpar ) ;

 DIFFPER_en(ssnp,kk)$(ABS(DIFFPER_en(ssnp,kk) lt 0.01)) = 0.0 ;

 CNTDIFFPER_en(kk)  = SUM(ssn$DIFFPER_en(ssn,kk), 1) ;

option decimals = 8 ;

DISPLAY COLTOT_en, ROWTOT_en,
        DIFFTOT_en, CNTDIFFTOT_en5, CNTDIFFTOT_en4, CNTDIFFTOT_en3,
        CNTDIFFTOT_en2, CNTDIFFTOT_en1, SUMDIFFTOT_en,
        DIFFPER_en, CNTDIFFPER_en ;



*#### Rounding Sales Tax Adjustments to 6 Decimal Places
* The GTAP database only records data to 6 decimal places


* Calculating input subsidies


*#### Rounding Sales Tax Adjustments to 6 Decimal Places
* The GTAP database only records data to 6 decimal places


*### Mappings for Input subsidy Accounts

* This writes all the SAM data to GDX
Execute_Unload  'globsam8107_GLBv2_en.gdx', SAMG_en
* GTAP Elasticity Values
                                   ESUBVA,
                                   ESUBD2,
                                   ESUBM2,
* Sales Taxes
                                   SMTAX,
                                   SDTAX,
                                   STAX,
* GTAP Energy Volumes
                                   EVol2,
                                   EVolT2,
* Factor based
                                   FacSubs,
                                   FacEmpTax,
* Activity based
                                   OutSubs2,
* Intermediate Input based
                                   IntInSubsM2,
                                   IntInSubsD2,
* Export based
                                   MFASubs2,
                                   OrdXSub2,
* Import based
                                   OrdMDuty2,
* GTAP population data
                                   Popn,
* GTAP Capital Stock Trade data
                                   Kstoc,
* GTAP Time series trade data
                                   TSTRAD2

  ;

*############## 13. COMPUTING TAX RATES ##################################

* #### Computed tax rates for checking impact of changes on tax rates

Parameter
 te0(cc,ww,kk)      Export tax rates on exports of comm'y c to region w
 tm0(ww,cc,kk)      Tariff rates on comm'y imported from region w
 ts0(cc,kk)         Base sales tax rate
 tv0(cc,kk)         Base Value added tax rates
 tx0(aa,kk)         Base indirect tax rate on activity a
 tyf0(ff,kk)        Factor income tax rate
 tyh0(*,kk)         Direct tax rate on household h
 tf0(ff,aa,kk)      Factor use tax rate
 ;

 ts0(cc,kk)$(SUM(aa,SAMG(cc,aa,kk)) + SAMG(cc,"hhous",kk) + SAMG(cc,"ggovt",kk)
                              + SAMG(cc,"kkap",kk) - SAMG("ssaltax",cc,kk)
                                        - SAMG("VVATTAX",cc,kk))
                 = SAMG("ssaltax",cc,kk)/(SUM(aa,SAMG(cc,aa,kk))
                                       + SAMG(cc,"hhous",kk)
                                       + SAMG(cc,"ggovt",kk)
                                       + SAMG(cc,"kkap",kk)
                                       - SAMG("ssaltax",cc,kk)
                                       - SAMG("VVATTAX",cc,kk) ) ;

 tv0(cc,kk)$(SAMG(cc,"hhous",kk) - SAMG("VVATTAX",cc,kk))
             = SAMG("VVATTAX",cc,kk)/
                (SAMG(cc,"hhous",kk) - SAMG("VVATTAX",cc,kk));

 tx0(aa,kk)$SAMG("TTOTAL",aa,kk)
             = SAMG("PPRODTAX",aa,kk)/SAMG("TTOTAL",aa,kk) ;

 tyf0(ff,kk)$(SAMG("TTOTAL",ff,kk) - SAMG("kkap",ff,kk))
             = SAMG("DDIRTAX",ff,kk)/(SAMG("TTOTAL",ff,kk) - SAMG("kkap",ff,kk)) ;

 tyh0("hhous",kk)$SAMG("TTOTAL","hhous",kk)
             = SAMG("DDIRTAX","hhous",kk)/SAMG("TTOTAL","hhous",kk) ;

Display ts0, tv0, tx0, tyh0, tyf0 ;

Parameter

 tv0_perc(cc,kk)     Percentage rates for VAT
 tv0_big(cc,kk)      Big percentage rates for VAT
 tv0_smal(cc,kk)     Small percentage rates for VAT

 tyh0_perc(*,kk)     Percentage rates for household income taxes
 tyh0_big(*,kk)      Big percentage rates for household income taxes

 tyf0_perc(ff,kk)    Percentage rates for factor income taxes
 tyf0_big(ff,kk)     Big percentage rates for factor income taxes

  ;

 tv0_perc(cc,kk)   = tv0(cc,kk) *100 ;

 tv0_big(cc,kk)$(ABS(tv0_perc(cc,kk) GT 25)) = tv0_perc(cc,kk) ;

 tv0_smal(cc,kk)$(ABS(tv0_perc(cc,kk) LT 1)) = tv0_perc(cc,kk) ;

 tyh0_perc("hhous",kk)   = tyh0("hhous",kk) *100 ;

 tyh0_big("hhous",kk)$(ABS(tyh0_perc("hhous",kk) GT 25)) = tyh0_perc("hhous",kk) ;

 tyf0_perc(ff,kk)    =  tyf0(ff,kk) * 100 ;

 tyf0_big(ff,kk)$(ABS(tyf0_perc(ff,kk) GT 10))  = tyf0_perc(ff,kk) ;

Option Decimals = 3 ;

Display tv0_perc, tv0_big, tv0_smal, tyh0_perc, tyh0_big, tyf0_perc, tyf0_big ;

Execute_Unload  'glb8107_tax_rate.gdx',  tv0_perc
                                         tv0_big
                                         tv0_smal
                                         tyh0_perc
                                         tyh0_big
                                         tyf0_perc
                                         tyf0_big
  ;



*############## 14. ADJUSTING THE GLOBAL SAM FOR GLB1 ####################

* Eliminating VAT

 SAMG("ssaltax",cc,kk) =  SAMG("vvattax",cc,kk) + SAMG("ssaltax",cc,kk) ;

 SAMG("vvattax",cc,kk) = 0.0 ;

* Eliminating Specific Tariffs

 SAMG(tmmtax,cc,kk) = SAMG(tmmtax,cc,kk)
                           + SUM(tmsstax$map_tmm_tms(tmmtax,tmsstax),
                                       SAMG(tmsstax,cc,kk)) ;

 SAMG(tmsstax,cc,kk) = 0.0 ;

* Recalculating Government tax revenues

 SAMG("ggovt","ssaltax",kk) = SUM(cc,SAMG("ssaltax",cc,kk)) ;

 SAMG("ggovt","vvattax",kk) = 0.0 ;

 SAMG("ggovt",tmmtax,kk) = SUM(cc,SAMG(tmmtax,cc,kk)) ;

 SAMG("ggovt",tmsstax,kk) = 0.0 ;

*############## 15. CHECKING THE GLOBAL SAMG FOR GLB1 ###################

* This checking of the Global SAM is important.

*#### Computing Account totals for Global SAM by Region

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Parameter
 COLTOT_glb1(*,kk)       Check on region column totals
 COLTOT_glb1_CHK(*,kk)   Check on Check on region column totals
 ROWTOT_glb1(kk,*)       Check on region row totals
 ROWTOT_glb1_CHK(kk,*)   Check on Check on region row totals
 DIFFTOT_glb1(*,kk)      Check on difference in region column and row totals
 SUMDIFFTOT_glb1(kk)     Sum of differences in region row and column totals
 DIFFPER_glb1(*,kk)      Percent differences in region column and row totals
 ;

 COLTOT_glb1(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT_glb1(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 COLTOT_glb1_CHK(ssnp,kk)$(COLTOT_glb1(ssnp,kk) = 0.0) = 1.0 ;
 ROWTOT_glb1_CHK(kk,ssn)$(ROWTOT_glb1(kk,ssn) = 0.0)   = 1.0 ;

Display COLTOT_glb1_CHK, ROWTOT_glb1_CHK ;

 DIFFTOT_glb1(ssnp,kk)   = COLTOT_glb1(ssnp,kk) - ROWTOT_glb1(kk,ssnp) ;

 DIFFTOT_glb1(ssnp,kk)   = ROUND(DIFFTOT_glb1(ssnp,kk),roundpar ) ;

 SUMDIFFTOT_glb1(kk)     = SUM(ssnp,DIFFTOT_glb1(ssnp,kk)) ;

 DIFFPER_glb1(ssnp,kk)$COLTOT_glb1(ssnp,kk)
      = (DIFFTOT_glb1(ssnp,kk)/(0.5 * (COLTOT_glb1(ssnp,kk)
                                    + ROWTOT_glb1(kk,ssnp)))) * 100 ;

 DIFFPER_glb1(ssnp,kk)   = ROUND(DIFFPER_glb1(ssnp,kk),roundpar ) ;

option decimals = 8 ;

DISPLAY COLTOT_glb1, ROWTOT_glb1, DIFFTOT_glb1, DIFFPER_glb1, SUMDIFFTOT_glb1 ;

*############## 15. WRITING THE GLOBAL SAM FOR GLB1 TO GDX ###############

*## Writing out the GTAP NEW SAM to GDX

IF(OUTGDXv3g = 1,

* This writes all the SAM data to GDX
Execute_Unload  'globsam8107_GLBv1.gdx', SAMG
* GTAP Elasticity Values
                                   ESUBVA,
                                   ESUBD2,
                                   ESUBM2,

* GTAP Energy Volumes
                                   EVol2,
                                   EVolT2,
* Factor based
                                   FacSubs,
                                   FacEmpTax,
* Activity based
                                   OutSubs2,
* Intermediate Input based
                                   IntInSubsM2,
                                   IntInSubsD2,
* Export based
                                   MFASubs2,
                                   OrdXSub2,
* Import based
                                   OrdMDuty2,
* GTAP population data
                                   Popn,
* GTAP Capital Stock Trade data
                                   Kstoc,
* GTAP Time series trade data
                                   TSTRAD2

  ;

   )  ;

*########################### THE END #####################################
